Bug 1706003 - python-cheetah FTBFS with Python 3.8
Summary: python-cheetah FTBFS with Python 3.8
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-cheetah
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Mike Bonnet
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F32FTBFS F32FailsToInstall PYTHON38 1731542
TreeView+ depends on / blocked
 
Reported: 2019-05-03 11:41 UTC by Miro Hrončok
Modified: 2019-09-17 16:49 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-17 16:49:38 UTC
Type: Bug


Attachments (Terms of Use)
Full log from Copr (3.67 MB, text/plain)
2019-05-03 11:41 UTC, Miro Hrončok
no flags Details

Description Miro Hrončok 2019-05-03 11:41:30 UTC
Created attachment 1562344 [details]
Full log from Copr

python-cheetah 3.1.0-8.fc31 fails to build with Python 3.8.

One failure is:

AttributeError: module 'cgi' has no attribute 'escape'

https://docs.python.org/3.8/whatsnew/3.8.html#api-and-feature-removals

> parse_qs, parse_qsl, and escape are removed from cgi module. They are deprecated from Python 3.2 or older.

https://docs.python.org/3.7/library/cgi.html#cgi.escape

> Deprecated since version 3.2: This function is unsafe because quote is false by default, and therefore deprecated. Use html.escape() instead.

Another failure is hard to parse, might not be Python 3.8 related.

+ /builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64//usr/bin/cheetah test
......................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................................EE........................FF.......FF.FF.FF.FF.FF.FF.FF.FF.FF.FF.FF.FF.FF.FF
======================================================================
ERROR: test_FailingBehavior (Cheetah.Tests.Regressions.Mantis_Issue_11_Regression_Test)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/Regressions.py", line 143, in test_FailingBehavior
    searchList=[{'escape': cgi.escape, 'request': 'foobar'}])
AttributeError: module 'cgi' has no attribute 'escape'

======================================================================
ERROR: test_FailingBehaviorWithSetting (Cheetah.Tests.Regressions.Mantis_Issue_11_Regression_Test)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/Regressions.py", line 151, in test_FailingBehaviorWithSetting
    searchList=[{'escape': cgi.escape, 'request': 'foobar'}],
AttributeError: module 'cgi' has no attribute 'escape'

======================================================================
FAIL: testFill (Cheetah.Tests.CheetahWrapper.Flat)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 457, in testFill
    self.go("cheetah fill --flat child/a.tmpl")
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 231, in go
    output = self.assertSubprocess(cmd)
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 213, in assertSubprocess
    self.assertEqual(status, 0, '''Subprocess exited with a non-zero status (%d)
AssertionError: 1 != 0 : Subprocess exited with a non-zero status (1)
                            b'Filling child/a.tmpl -> ...snip...
======================================================================
FAIL: testText (Cheetah.Tests.CheetahWrapper.VarietyWithOdir)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 389, in testText
    self.go("cheetah fill --odir DEST --oext txt "
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 231, in go
    output = self.assertSubprocess(cmd)
  File "/builddir/build/BUILDROOT/python-cheetah-3.1.0-8.fc31.x86_64/usr/lib64/python3.8/site-packages/Cheetah/Tests/CheetahWrapper.py", line 213, in assertSubprocess
    self.assertEqual(status, 0, '''Subprocess exited with a non-zero status (%d)
AssertionError: 1 != 0 : Subprocess exited with a non-zero status (1)
                            b'Filling a.tmpl -> ...snip...
....lot of similar failures....

----------------------------------------------------------------------
Ran 2162 tests in 14.515s

FAILED (failures=30, errors=2)

Full log attached.

Comment 1 Miro Hrončok 2019-07-10 10:35:10 UTC
Please respond.

Comment 2 Ben Cotton 2019-08-13 16:55:30 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 3 Ben Cotton 2019-08-13 18:59:59 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 4 Miro Hrončok 2019-08-14 22:24:32 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 5 Miro Hrončok 2019-08-21 16:35:17 UTC
The f32-python side tag has been merged. In order to rebuild the package, do it in regular rawhide, but please wait until python3-3.8 is tagged:

  $ koji wait-repo f32-build --build python3-3.8.0~b3-3.fc32


If your built already started in f32-python, after it is finished, please tag it to rawhide with:

  $ koji tag-build f32-pending <nvr>

For example:

  $ koji tag-build f32-pending libreoffice-6.3.0.4-3.fc32

Thanks!

(This comment is mass posted to all bugzillas blocking the PYTHON38 tracking bug.)

Comment 6 Miro Hrončok 2019-08-21 17:29:20 UTC
(Python 3.8 has landed in the rawhide buildroot.)

Comment 7 Mike Bonnet 2019-08-27 15:02:23 UTC
The Cheetah tests are failing under Python 3.8. Filed an issue upstream: https://github.com/CheetahTemplate3/cheetah3/issues/21


Note You need to log in before you can comment on or make changes to this bug.